unit SmartURLLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ShellApi,DsgnIntf;

type string20 = string[20];
type
  Taboutproperty = class(Tpropertyeditor)
  public
    function getvalue:string; override;
    procedure setvalue(const value :string); override;
    procedure edit;override;
    function getattributes:Tpropertyattributes; override;
  end;

type
  TSmartURLLabel = class(TLabel)
  private
    FAbout  :string20;
    FURL    :string;
    procedure seturl(value :string);
    procedure fonclickproc(Sender:TObject);
  protected
    constructor create(AOwner:TComponent); override;
  public
    { Public declarations }
  published
    property About :string20 read FAbout write FAbout;
    property URL :string read FURL write seturl;
  end;

procedure Register;

implementation
uses u_compabout;

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(string20),TSmartURLLabel,'About',Taboutproperty);
  RegisterComponents('Smart', [TSmartURLLabel]);
end;

constructor TSmartURLLabel.create(AOwner:TComponent);
begin
  inherited create(AOwner);
  onclick:=fonclickproc;
  cursor:=crhandpoint;
  font.color:=clblue;
  FAbout:='Press ... to Display';
end;

procedure TSmartURLLabel.seturl(value :string);
begin
  FURL:=value;
  if length(FURL)>0 then
  begin
    hint:='Connect to ' + FURL;
    showhint:=true;
    parentshowhint:=false;
  end;
end;

procedure TSmartURLLabel.fonclickproc(Sender:TObject);
begin
  ShellExecute(TForm(Owner).Handle , 'open' , pchar(URL) , '' , '' ,0 );
end;

function Taboutproperty.getattributes:Tpropertyattributes;
begin
  Result := [paDialog];
end;

procedure Taboutproperty.setvalue(const value:string);
begin
  setstrvalue(value);
end;

procedure Taboutproperty.edit;
var f_compabout  :Tf_compabout;
begin
  f_compabout:=Tf_compabout.create(nil,'SmartURLLabel');
  f_compabout.showmodal;
  f_compabout.free;
end;

function Taboutproperty.getvalue:string;
begin
  result:=getstrvalue;
end;

end.
