unit u_main;

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms,Windows,
  StdCtrls, ExtCtrls, Buttons, Clipbrd, Comctrls, ImgList, Dialogs, Menus,
  Registry, DsgnIntf, TypInfo, ToolWin,IniFiles, ShellApi, FileHistory;

const max_keywords = 1000;
const max_propcount = 1000;
const max_eventcount = 100;
const max_methodcount = 100;
const max_templ = 1000;

type
  Tf_main = class(TForm)
    ToolBar1: TToolBar;
    tb_exit: TToolButton;
    tb_options: TToolButton;
    tb_gen_rtf: TToolButton;
    tb_gen_project: TToolButton;
    lb_comps: TListBox;
    Splitter1: TSplitter;
    lb_detail: TListBox;
    tb_help: TToolButton;
    MainMenu1: TMainMenu;
    Options1: TMenuItem;
    Generate1: TMenuItem;
    rtfFile1: TMenuItem;
    Projectfile1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    File1: TMenuItem;
    OpenHelpProjectfile1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    NewHelpProjectfile1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    iml: TImageList;
    Contents1: TMenuItem;
    N2: TMenuItem;
    SaveProjectfileas1: TMenuItem;
    N3: TMenuItem;
    HelpFile1: TMenuItem;
    fh_project: TFileHistory;
    N4: TMenuItem;
    procedure tb_exitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lb_compsClick(Sender: TObject);
    procedure lb_detailClick(Sender: TObject);
    procedure tb_optionsClick(Sender: TObject);
    procedure tb_gen_rtfClick(Sender: TObject);
    procedure OpenHelpProjectfile1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure NewHelpProjectfile1Click(Sender: TObject);
    procedure tb_gen_projectClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure HelpFile1Click(Sender: TObject);
    procedure fh_projectItemClick(Sender: TObject);
  private
    procedure AddType (pti: PTypeInfo);
    procedure init_keywords;
    procedure read_property_templates;
    procedure read_method_templates;
    procedure read_methods;
    procedure read_ini;
    procedure write_ini;
    procedure write_helpproject_file;
  public
    procedure write_main_page;
    procedure write_property_list;
    procedure write_method_list;
    procedure write_event_list;
    procedure write_properties;
    procedure write_events;
    procedure write_methods;
    function property_description(prop_name :string):string;
    function property_note(prop_name :string):string;
    function method_description(method_name :string):string;
    function method_note(method_name :string):string;
    function get_comp_description(comp_name :string):string;
    function get_comp_note(comp_name :string):string;
  end;

  procedure SortPropList(PropList: PPropList; PropCount: Integer); assembler;
  function ReplaceStr(Source, FromStr, ToStr :String):String;

// CreateProcessAndWait executes program given by AppPath and
// suspends the current thread until AppPath terminates
  function CreateProcessAndWait(const AppPath, AppParams: String;
                                Visibility: word): DWord;

var
  f_main: Tf_main;

  pti                :PTypeInfo;

  keywords           :array[1..max_keywords] of string[20];
  keyvalues          :array[1..max_keywords] of string[50];
  keyword_count      :integer;

  prop_name_templ_list   :array[1..max_templ] of string[30];
  prop_desc_templ_list   :array[1..max_templ] of string;
  prop_templ_list_count :integer;
  method_name_templ_list :array[1..max_templ] of string[30];
  method_desc_templ_list :array[1..max_templ] of string;
  method_templ_list_count :integer;

  prop_name          :array[1..max_propcount] of string[50];
  prop_type          :array[1..max_propcount] of string[50];
  prop_count         :integer;

  method_name        :array[1..max_methodcount] of string[50];
  method_type        :array[1..max_propcount] of string[9];
  method_detail      :array[1..max_methodcount] of string[255];
  method_count       :integer;

  event_name         :array[1..max_eventcount] of string[50];
  event_type         :array[1..max_eventcount] of string[50];
  event_count        :integer;

  compname           :string[30];
  compnameexcl       :string[30];

  properties_templ   :string;
  methods_templ      :string;
  comp_descriptions  :string;

  projectfile        :string;
  helpfile,
  helptitle,
  rtffile,
  copyright_display,
  copyright_print,
  mainw_title,
  mainw_comment,
  propw_title,
  propw_comment,
  templ_prop,
  templ_method,
  templ_desc,
  props,main,
  prop_list, prop_page,
  method_list, method_page,
  event_list, event_page,
  main_page,
  helpcompiler       :string;
  doload            :boolean;

implementation

uses u_options,
     u_generate, u_about,

     smartcheckbox;

{$R *.DFM}

procedure Tf_main.tb_exitClick(Sender: TObject);
begin
  write_ini;
  close;
end;

procedure Tf_main.FormCreate(Sender: TObject);
begin
  // add classes to the first listbox
  AddType (TypeInfo (TSmartCheckBox));

  NewHelpProjectfile1Click(self);
  fh_project.LoadFromFile(extractfilepath(application.ExeName) + 'CompHelpGen.His');

end;

// code extracted from TypInfo.pas
procedure SortPropList(PropList: PPropList; PropCount: Integer); assembler;
asm
        { ->    EAX Pointer to prop list        }
        {       EDX Property count              }
        { <-    nothing                         }

        PUSH    EBX
        PUSH    ESI
        PUSH    EDI
        MOV     ECX,EAX
        XOR     EAX,EAX
        DEC     EDX
        CALL    @@qsort
        POP     EDI
        POP     ESI
        POP     EBX
        JMP     @@exit

@@qsort:
        PUSH    EAX
        PUSH    EDX
        LEA     EDI,[EAX+EDX]           { pivot := (left + right) div 2 }
        SHR     EDI,1
        MOV     EDI,[ECX+EDI*4]
        ADD     EDI,OFFSET TPropInfo.Name
@@repeat:                               { repeat                        }
@@while1:
        CALL    @@compare               { while a[i] < a[pivot] do inc(i);}
        JAE     @@endWhile1
        INC     EAX
        JMP     @@while1
@@endWhile1:
        XCHG    EAX,EDX
@@while2:
        CALL    @@compare               { while a[j] > a[pivot] do dec(j);}
        JBE     @@endWhile2
        DEC     EAX
        JMP     @@while2
@@endWhile2:
        XCHG    EAX,EDX
        CMP     EAX,EDX                 { if i <= j then begin          }
        JG      @@endRepeat
        MOV     EBX,[ECX+EAX*4]         { x := a[i];                    }
        MOV     ESI,[ECX+EDX*4]         { y := a[j];                    }
        MOV     [ECX+EDX*4],EBX         { a[j] := x;                    }
        MOV     [ECX+EAX*4],ESI         { a[i] := y;                    }
        INC     EAX                     { inc(i);                       }
        DEC     EDX                     { dec(j);                       }
                                        { end;                          }
        CMP     EAX,EDX                 { until i > j;                  }
        JLE     @@repeat

@@endRepeat:
        POP     ESI
        POP     EBX

        CMP     EAX,ESI
        JL      @@rightNonEmpty         { if i >= right then begin      }
        CMP     EDX,EBX
        JG      @@leftNonEmpty1         { if j <= left then exit        }
        RET

@@leftNonEmpty1:
        MOV     EAX,EBX
        JMP     @@qsort                 { qsort(left, j)                }

@@rightNonEmpty:
        CMP     EAX,EBX
        JG      @@leftNonEmpty2
        MOV     EDX,ESI                 { qsort(i, right)               }
        JMP     @@qsort
@@leftNonEmpty2:
        PUSH    EAX
        PUSH    ESI
        MOV     EAX,EBX
        CALL    @@qsort                 { qsort(left, j)                }
        POP     EDX
        POP     EAX
        JMP     @@qsort                 { qsort(i, right)               }

@@compare:
        PUSH    EAX
        PUSH    EDI
        MOV     ESI,[ECX+EAX*4]
        ADD     ESI,OFFSET TPropInfo.Name
        PUSH    ESI
        XOR     EBX,EBX
        MOV     BL,[ESI]
        INC     ESI
        CMP     BL,[EDI]
        JBE     @@firstLenSmaller
        MOV     BL,[EDI]
@@firstLenSmaller:
        INC     EDI
        TEST    BL,BL
        JE      @@endLoop
@@loop:
        MOV     AL,[ESI]
        MOV     AH,[EDI]
        AND     EAX,$DFDF
        CMP     AL,AH
        JNE     @@difference
        INC     ESI
        INC     EDI
        DEC     EBX
        JNZ     @@loop
@@endLoop:
        POP     ESI
        POP     EDI
        MOV     AL,[ESI]
        MOV     AH,[EDI]
        CMP     AL,AH
        POP     EAX
        RET
@@difference:
        POP     ESI
        POP     EDI
        POP     EAX
        RET
@@exit:
end;

// show RTTI information for class type
procedure ShowClass (pti: PTypeInfo; sList: TStrings);
var
  ptd: PTypeData;
  ppi: PPropInfo;
  pProps: PPropList;
  nProps, I: Integer;
  ParentClass: TClass;
begin
  // protect against misuse
  if pti^.Kind <> tkClass then
    raise Exception.Create ('Invalid type information');

  // get a pointer to the TTypeData structure
  ptd := GetTypeData (pti);

  // access the TTypeInfo structure
  sList.Add ('Type Name: ' + pti^.Name);
  sList.Add ('Type Kind: ' + GetEnumName (TypeInfo (TTypeKind),Integer (pti^.Kind)));

  // access the TTypeData structure
  {omitted: the same information of pti^.Name...
  sList.Add ('ClassType: ' + ptd^.ClassType.ClassName);}
  sList.Add ('Size: ' + IntToStr (ptd^.ClassType.InstanceSize) + ' bytes');
  sList.Add ('Defined in: ' + ptd^.UnitName + '.pas');

  // add the list of parent classes (if any)
  ParentClass := ptd^.ClassType.ClassParent;
  if ParentClass <> nil then
  begin
    sList.Add ('');
    sList.Add ('=== Parent classes ===');
    while ParentClass <> nil do
    begin
      sList.Add (ParentClass.ClassName);
      ParentClass := ParentClass.ClassParent;
    end;
  end;

  // add the list of properties (if any)
  nProps := ptd^.PropCount;
  if nProps > 0 then
  begin
    // format the initial output
    sList.Add ('');
    sList.Add ('=== Properties (' +
      IntToStr (nProps) + ') ===');
    // allocate the required memory
    GetMem (pProps, sizeof (PPropInfo) * nProps);
    // protect the memory allocation
    try
      // fill the TPropList structure
      // pointed to by pProps
      GetPropInfos(pti, pProps);
      // sort the properties
      SortPropList(pProps, nProps);
      // show name and data type of each property
      for I := 0 to nProps - 1 do
      begin
        ppi := pProps [I];
{        if ppi.proptype^.Kind <> tkMethod then}
        begin
          sList.Add (ppi.Name + ': ' +
            ppi.PropType^.Name);
        end;
      end;
    finally
      // free the allocated memmory
      FreeMem (pProps, sizeof (PPropInfo) * nProps);
    end;
  end;
end;

procedure Tf_main.AddType (pti: PTypeInfo);
begin
  lb_comps.Items.AddObject(pti.Name, TObject (pti));
end;

procedure Tf_main.lb_compsClick(Sender: TObject);
begin
  pti := PTypeInfo (lb_comps.Items.Objects [
    lb_comps.ItemIndex]);
  lb_detail.Items.Clear;
//  Caption := 'RTTI information for ' + lb_comps.Items [lb_comps.ItemIndex];
  ShowClass (pti, lb_detail.Items);

end;

procedure Tf_main.lb_detailClick(Sender: TObject);
var
  Text: string;
  Index: Integer;
  pti: PTypeInfo;
begin
  // get the current item
  Text := lb_detail.Items [lb_detail.ItemIndex];
  // search the first listbox
  Index := lb_comps.Items.IndexOf (Text);
  // if found, it was a parent class: show RTTI
  if Index >= 0 then
  begin
    pti := PTypeInfo (lb_comps.Items.Objects [Index]);
    Caption := 'RTTI information for ' + Text;
    lb_detail.Items.Clear;
    ShowClass (pti, lb_detail.Items);
  end;
end;

procedure Tf_main.tb_optionsClick(Sender: TObject);
var
  f_options: Tf_options;
begin
  f_options:=tf_options.create(self);

  f_options.e_helpfile.text:=helpfile;
  f_options.e_helptitle.text:=helptitle;
  f_options.e_rtffile.text:=rtffile;
  f_options.e_copyright_display.text:=copyright_display;
  f_options.e_copyright_print.text:=copyright_print;

  f_options.e_propw_title.text:=propw_title;
  f_options.e_propw_comment.text:=propw_comment;
  f_options.e_mainw_title.text:=mainw_title;
  f_options.e_mainw_comment.text:=mainw_comment;

  f_options.e_templ_prop.text:=templ_prop;
  f_options.e_templ_method.text:=templ_method;
  f_options.e_templ_desc.text:=templ_desc;

  f_options.e_mainw_title.text:=mainw_title;
  f_options.e_mainw_comment.text:=mainw_comment;
  f_options.e_propw_title.text:=propw_title;
  f_options.e_propw_comment.text:=propw_comment;

  f_options.e_templ_prop.text:=templ_prop;
  f_options.e_templ_method.text:=templ_method;
  f_options.e_templ_desc.text:=templ_desc;

  f_options.e_prop_list.text:=prop_list;
  f_options.e_prop_page.text:=prop_page;
  f_options.e_method_list.text:=method_list;
  f_options.e_method_page.text:=method_page;
  f_options.e_event_list.text:=event_list;
  f_options.e_event_page.text:=event_page;
  f_options.e_main_page.text:=main_page;

  f_options.e_helpcompiler.text:=helpcompiler;

  f_options.showmodal;

  if f_options.ModalResult = mrOk then
  begin
    helpfile:=f_options.e_helpfile.text;
    helptitle:=f_options.e_helptitle.text;
    rtffile:=f_options.e_rtffile.text;
    copyright_display:=f_options.e_copyright_display.text;
    copyright_print:=f_options.e_copyright_print.text;

    propw_title:=f_options.e_propw_title.text;
    propw_comment:=f_options.e_propw_comment.text;
    mainw_title:=f_options.e_mainw_title.text;
    mainw_comment:=f_options.e_mainw_comment.text;

    templ_prop:=f_options.e_templ_prop.text;
    templ_method:=f_options.e_templ_method.text;
    templ_desc:=f_options.e_templ_desc.text;

    mainw_title:=f_options.e_mainw_title.text;
    mainw_comment:=f_options.e_mainw_comment.text;
    propw_title:=f_options.e_propw_title.text;
    propw_comment:=f_options.e_propw_comment.text;

    templ_prop:=f_options.e_templ_prop.text;
    templ_method:=f_options.e_templ_method.text;
    templ_desc:=f_options.e_templ_desc.text;

    prop_list:=f_options.e_prop_list.text;
    prop_page:=f_options.e_prop_page.text;
    method_list:=f_options.e_method_list.text;
    method_page:=f_options.e_method_page.text;
    event_list:=f_options.e_event_list.text;
    event_page:=f_options.e_event_page.text;
    main_page:=f_options.e_main_page.text;
    helpcompiler:=f_options.e_helpcompiler.text;

    write_ini;

//    write_helpproject_file;

  end;

  f_options.Free;
end;

procedure Tf_main.tb_gen_rtfClick(Sender: TObject);
var ptd         :PTypeData;
    ppi         :PPropInfo;
    pProps      :PPropList;
    nProps,I    :Integer;
    ParentClass :TClass;


begin
  if (lb_comps.itemindex<0) then
    exit;

  ptd := GetTypeData (pti);
  nProps := ptd^.PropCount;
  prop_count:=nProps;
  if prop_count<=0 then
    exit;

  init_keywords;
  read_property_templates;
  read_method_templates;

  compname:=lb_comps.items[lb_comps.itemindex];
  compnameexcl:=compname;
  delete(compnameexcl,pos('T',uppercase(compnameexcl)),1);

  opendialog1.Title:='Open Method File';
  opendialog1.FilterIndex:=1;
  opendialog1.filename:=lowercase(compnameexcl)+'.txt';
  method_count:=0;
  if opendialog1.execute then
  begin
    read_methods;
  end;

  savedialog1.Title:='Generate Rich Text file';
  savedialog1.FilterIndex:=1;

  savedialog1.filename:=lowercase(rtffile);
  if savedialog1.execute then
  begin

    f_generate:=tf_generate.create(self);

    compname:=lb_comps.items[lb_comps.itemindex];
    compnameexcl:=compname;
    delete(compnameexcl,pos('T',uppercase(compnameexcl)),1);

    if pti^.Kind <> tkClass then
      raise Exception.Create ('Invalid type information');

    ptd := GetTypeData (pti);

    nProps := ptd^.PropCount;
    if nProps > 0 then
    begin
      prop_count:=0;
      event_count:=0;
      GetMem (pProps, sizeof (PPropInfo) * nProps);
      try
        // fill the TPropList structure
        // pointed to by pProps
        GetPropInfos(pti, pProps);
        // sort the properties
        SortPropList(pProps, nProps);
        // show name and data type of each property
        for I := 0 to nProps - 1 do
        begin
          ppi := pProps [I];
          if ppi.PropType^.Kind <> tkMethod then
          begin
            inc(prop_count);
            f_generate.lb_properties.Items.Add(ppi.Name);
            prop_name[prop_count]:=ppi.Name;
            prop_type[prop_count]:=ppi.PropType^.Name;
          end;
          if ppi.PropType^.Kind = tkMethod then
          begin
            inc(event_count);
            f_generate.lb_events.Items.Add(ppi.Name);
            event_name[event_count]:=ppi.Name;
            event_type[event_count]:=ppi.PropType^.Name;
          end;

        end;
      finally
        // free the allocated memmory
        FreeMem (pProps, sizeof (PPropInfo) * nProps);
       end;
     end;
    keyvalues[1]:=compnameexcl;
    keyvalues[13]:=compnameexcl + '.bmp';
    keyvalues[14]:=compname;
    keyvalues[15]:=compnameexcl;

    if prop_count=0 then
    begin
      exit;
    end;

    f_generate.showmodal;
    f_generate.free;

{    write_main_page;
    write_property_list;
    write_method_list;
    write_event_list;

    write_properties;
    write_methods;
    write_events;}

  end;
end;

procedure Tf_main.init_keywords;
begin
  keyword_count:=17;

  keywords[1]:='_CompBitMap_';
  keywords[2]:='_Author_';
  keywords[3]:='_Operator_';
  keywords[4]:='_CrYear_';
  keywords[5]:='_CrMonth_';
  keywords[6]:='_CrDay_';
  keywords[7]:='_CrHour_';
  keywords[8]:='_CrMin_';
  keywords[9]:='_NoOfPages_';
  keywords[10]:='_NoOfWords_';
  keywords[11]:='_NoOfChars_';
  keywords[12]:='_Company_';
  keywords[13]:='_CompBitMapInc_';
  keywords[14]:='_CompName_';
  keywords[15]:='_CompNameExcl_';
  keywords[16]:='_Description_';
  keywords[17]:='_Note_';

  keyvalues[1]:='Title';
  keyvalues[2]:='Author Name';
  keyvalues[3]:='Author Name';
  keyvalues[4]:='1998';
  keyvalues[5]:='4';
  keyvalues[6]:='10';
  keyvalues[7]:='23';
  keyvalues[8]:='27';
  keyvalues[9]:='2';
  keyvalues[10]:='30';
  keyvalues[11]:='300';
  keyvalues[12]:='Company Name';
  keyvalues[14]:='_CompName_';
  keyvalues[15]:='_CompNameExcl_';
  keyvalues[16]:='This is the description of the component';
  keyvalues[17]:='Any notes needed';
end;

procedure Tf_main.read_method_templates;
var fin               :textfile;
    method_name         :string[30];
    method_description  :string;
begin
  method_templ_list_count:=0;
  assignfile(fin,templ_method);
  reset(fin);
  while not eof(fin) do
  begin
    inc(method_templ_list_count);
    readln(fin,method_name,method_description);
    method_name_templ_list[method_templ_list_count]:=trim(method_name);
    method_desc_templ_list[method_templ_list_count]:=trim(method_description);
  end;
  closefile(fin);
end;

procedure Tf_main.read_property_templates;
var fin               :textfile;
    prop_name         :string[30];
    prop_description  :string;
begin
  prop_templ_list_count:=0;
  assignfile(fin,templ_prop);

  reset(fin);
  while not eof(fin) do
  begin
    inc(prop_templ_list_count);
    readln(fin,prop_name,prop_description);
    prop_name_templ_list[prop_templ_list_count]:=trim(prop_name);
    prop_desc_templ_list[prop_templ_list_count]:=trim(prop_description);
  end;
  closefile(fin);
end;

procedure Tf_main.read_methods;
var fin        :textfile;
    l          :string[255];
    first_part :string[9];
    name       :string[30];

begin
  assignfile(fin,opendialog1.filename);
  reset(fin);
  method_count:=0;
  while not eof(fin) do
  begin
    readln(fin,l);
    first_part:=l;
    if (trim(first_part) = 'procedure')
      or (trim(first_part) = 'function') then
    begin
      name:=trim(copy(l,10,length(l)-9));
      inc(method_count);
      method_type[method_count]:=first_part;
      method_name[method_count]:=name;
      method_detail[method_count]:='';
    end
    else
    begin
      method_detail[method_count]:=l;
    end;
  end;
end;

procedure Tf_main.write_event_list;
var fout        :textfile;
    fin         :textfile;
    line_in     :string;
    line_out    :string;
    line_hold   :string;
    i,j         :integer;
begin
  assignfile(fout,savedialog1.filename);
  append(fout);

  assignfile(fin,'e:\proj\helpgen\event_list.txt');
  reset(fin);

  for j:=1 to 4 do
  begin
    readln(fin,line_in);
    for i:=1 to keyword_count do
    begin
      line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
      line_in:=line_out;
    end;
    writeln(fout,line_in);
  end;

  readln(fin,line_hold);
  for j:=1 to event_count do
  begin
    line_in:=line_hold;
    for i:=1 to keyword_count do
    begin
      line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
      line_in:=line_out;
    end;
    line_out:=replacestr(line_in,'_EventName_',event_name[j]);

    line_in:=line_out;
    writeln(fout,line_in);
  end;
  for j:=1 to 2 do
  begin
    readln(fin,line_in);
    writeln(fout,line_in);
  end;

  closefile(fin);
  closefile(fout);
end;

procedure Tf_main.write_events;
var fout        :textfile;
    fin         :textfile;
    line_in     :string;
    line_out    :string;
    line_hold   :string;
    i,j         :integer;
begin
  assignfile(fout,savedialog1.filename);
  append(fout);

  assignfile(fin,event_page);

  for j:=1 to event_count do
  begin
    reset(fin);
    while not eof(fin) do
    begin
      readln(fin,line_hold);

      line_in:=line_hold;
      for i:=1 to keyword_count do
      begin
        line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
        line_in:=line_out;
      end;
      line_out:=replacestr(line_in,'_EventName_',event_name[j]);
      line_in:=line_out;
      line_out:=replacestr(line_in,'_EventType_',event_type[j]);
      line_in:=line_out;
      writeln(fout,line_in);
    end;
    closefile(fin);
    if j<> event_count then
    begin
      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright {\page }');
    end
    else
    begin
      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright{\f1 ');
      writeln(fout,'\par }}');
    end
  end;

  closefile(fout);
end;

procedure Tf_main.write_main_page;
var fout        :textfile;
    fin         :textfile;
    line_in     :string;
    line_out    :string;
    i           :integer;
    comp_desc   :string;
    comp_note   :string;

begin

  assignfile(fout,savedialog1.filename);
  rewrite(fout);
  assignfile(fin,main_page);
  reset(fin);

  comp_desc:=get_comp_description(compnameexcl);
  comp_note:=get_comp_note(compnameexcl);

  while not eof(fin) do
  begin
    readln(fin,line_in);

    for i:=1 to keyword_count do
    begin
      line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
      line_in:=line_out;
    end;

    line_out:=replacestr(line_in,'_CompDescription_',comp_desc);
    line_in:=line_out;
    line_out:=replacestr(line_in,'_CompNote_',comp_note);
    line_in:=line_out;

    writeln(fout,line_in);
  end;

  closefile(fin);
  closefile(fout);
end;

procedure Tf_main.write_method_list;
var fout        :textfile;
    fin         :textfile;
    line_in     :string;
    line_out    :string;
    line_hold   :string;
    i,j         :integer;
begin
  assignfile(fout,savedialog1.filename);
  append(fout);

  assignfile(fin,method_list);
  reset(fin);

  for j:=1 to 4 do
  begin
    readln(fin,line_in);
    for i:=1 to keyword_count do
    begin
      line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
      line_in:=line_out;
    end;
    writeln(fout,line_in);
  end;

  readln(fin,line_hold);
  for j:=1 to method_count do
  begin
    line_in:=line_hold;
    for i:=1 to keyword_count do
    begin
      line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
      line_in:=line_out;
    end;
    line_out:=replacestr(line_in,'_MethodName_',method_name[j]);

    line_in:=line_out;
    writeln(fout,line_in);
  end;
  for j:=1 to 2 do
  begin
    readln(fin,line_in);
    writeln(fout,line_in);
  end;

  closefile(fin);
  closefile(fout);
end;

procedure Tf_main.write_methods;
var fout        :textfile;
    fin         :textfile;
    line_in     :string;
    line_out    :string;
    line_hold   :string;
    i,j         :integer;
begin
  assignfile(fout,savedialog1.filename);
  append(fout);

  assignfile(fin,method_page);

  for j:=1 to method_count do
  begin
    reset(fin);
    while not eof(fin) do
    begin
      readln(fin,line_hold);

      line_in:=line_hold;
      for i:=1 to keyword_count do
      begin
        line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
        line_in:=line_out;
      end;

      line_out:=replacestr(line_in,'_MethodDescription_',method_description(method_name[j]));
      line_in:=line_out;
      line_out:=replacestr(line_in,'_MethodNote_',method_note(method_name[j]));
      line_in:=line_out;

      line_out:=replacestr(line_in,'_MethodName_',method_name[j]);
      line_in:=line_out;
      line_out:=replacestr(line_in,'_MethodType_',method_type[j]);
      line_in:=line_out;
      line_out:=replacestr(line_in,'_MethodDetail_',method_detail[j]);
      line_in:=line_out;
      writeln(fout,line_in);
    end;
    if j<>method_count then
    begin
      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright {\page }');
    end
    else
    if event_count>0 then
      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright {\page }')
    else
    begin
      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright {\f1');
      writeln(fout,'\par }}');
    end;

    closefile(fin);
    writeln(fout);

  end;
  closefile(fout);
end;

procedure Tf_main.write_properties;
var fout        :textfile;
    fin         :textfile;
    line_in     :string;
    line_out    :string;
    line_hold   :string;
    i,j         :integer;
begin
  assignfile(fout,savedialog1.filename);
  append(fout);

  assignfile(fin,prop_page);

  for j:=1 to prop_count do
  begin
    reset(fin);
    while not eof(fin) do
    begin
      readln(fin,line_hold);

      line_in:=line_hold;
      for i:=1 to keyword_count do
      begin
        line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
        line_in:=line_out;
      end;

      line_out:=replacestr(line_in,'_PropDescription_',property_description(prop_name[j]));
      line_in:=line_out;
      line_out:=replacestr(line_in,'_PropNote_',property_note(prop_name[j]));
      line_in:=line_out;

      line_out:=replacestr(line_in,'_PropName_',prop_name[j]);
      line_in:=line_out;
      line_out:=replacestr(line_in,'_PropType_',prop_type[j]);
      line_in:=line_out;
      writeln(fout,line_in);
    end;
    if j<>prop_count then
    begin
      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright {\page }');
    end
    else
    if method_count>0 then
      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright {\page }')
    else
    begin
      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright {\page }');
//      writeln(fout,'\par }\pard \li144\sa120\keepn\nowidctlpar\widctlpar\adjustright {\f1');
//      writeln(fout,'\par }}');

    end;

    closefile(fin);
    writeln(fout);

  end;
  closefile(fout);
end;

procedure Tf_main.write_property_list;
var fout        :textfile;
    fin         :textfile;
    line_in     :string;
    line_out    :string;
    line_hold   :string;
    i,j         :integer;
begin
  assignfile(fout,savedialog1.filename);
  append(fout);

  assignfile(fin,prop_list);
  reset(fin);

  for j:=1 to 4 do
  begin
    readln(fin,line_in);
    for i:=1 to keyword_count do
    begin
      line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
      line_in:=line_out;
    end;
    writeln(fout,line_in);
  end;

  readln(fin,line_hold);
  for j:=1 to prop_count do
  begin
    line_in:=line_hold;
    for i:=1 to keyword_count do
    begin
      line_out:=replacestr(line_in,keywords[i],keyvalues[i]);
      line_in:=line_out;
    end;
    line_out:=replacestr(line_in,'_PropName_',prop_name[j]);
    line_in:=line_out;
    writeln(fout,line_in);
  end;
  for j:=1 to 4 do
  begin
    readln(fin,line_in);
    writeln(fout,line_in);
  end;

//  writeln(fout,'{\f1 \par}');  //xxx
  closefile(fin);
  closefile(fout);
end;

function ReplaceStr(Source, FromStr, ToStr :String):String;
var tmp_str   :string;
    where     :integer;
begin
  where:=pos(FromStr,Source);
  while where > 0 do
  begin
    where:=pos(FromStr,Source);
    delete(Source,where,length(FromStr));
    insert(ToStr,Source,where);
    where:=pos(FromStr,Source);
  end;
  Result:=Source;
end;

function Tf_main.get_comp_description(comp_name: string): string;
var fin       :textfile;
    comp_nm   :string[30];
    comp_desc :string;
begin
  assignfile(fin,templ_desc);
  reset(fin);
  result:='Description of ' + comp_name;
  while not eof(fin) do
  begin
    readln(fin,comp_nm,comp_desc);
    if trim(uppercase(comp_name)) = trim(uppercase(comp_nm)) then
    begin
      result:=comp_desc;
      closefile(fin);
      exit;
    end;
  end;
  closefile(fin);
end;

function Tf_main.get_comp_note(comp_name: string): string;
begin
  result:='';
end;

function Tf_main.method_description(method_name: string): string;
var i,j      :integer;
begin
  result:='Description of ' + method_name;
  for i:=1 to method_templ_list_count do
  begin
    if trim(method_name_templ_list[i])=trim(method_name) then
    begin
      result:=method_desc_templ_list[i];
      exit;
    end;
  end;
end;

function Tf_main.method_note(method_name: string): string;
begin
  result:='';
end;

function Tf_main.property_description(prop_name: string): string;
var i,j      :integer;
begin
  result:='Description of ' + prop_name;
  for i:=1 to prop_templ_list_count do
  begin
    if trim(prop_name_templ_list[i])=trim(prop_name) then
    begin
      result:=prop_desc_templ_list[i];
      exit;
    end;
  end;
end;

function Tf_main.property_note(prop_name: string): string;
begin
  result:='';
end;

procedure Tf_main.OpenHelpProjectfile1Click(Sender: TObject);
var
  aInifile      :TIniFile;
  pos1, pos2,i  :integer;
  fnd           :byte;
  afile         :textfile;
  l             :string;

begin
  opendialog1.Title:='Open Help Project File';
  opendialog1.FilterIndex:=2;

  if not doload then
  begin
    if opendialog1.execute then
    begin
      projectfile:=opendialog1.filename;
      doload:=true;
    end;
  end;

  if doload then
  begin

    doload:=false;
    fh_project.AddHistory(projectfile);
    fh_project.SaveToFile(extractfilepath(application.ExeName) + 'CompHelpGen.His');
    assignfile(afile,projectfile);
    reset(afile);
    while not eof(afile) do
    begin
      readln(afile,l);
      if lowercase(l)='[files]' then
      begin
        readln(afile,l);
        rtffile:=l;
        break;
      end;
    end;
    closefile(afile);

    aInifile := TIniFile.Create(projectfile);
    with aInifile do
    begin
      helptitle:=ReadString('OPTIONS', 'TITLE', '');
      copyright_display:=ReadString('OPTIONS', 'COPYRIGHT', '');
      copyright_print:=ReadString('OPTIONS', 'CITATION', '');
      helpfile:=ReadString('OPTIONS', 'HLP', '');

      props:=ReadString('WINDOWS', 'Props', '');
      main:=ReadString('WINDOWS', 'Main', '');
    end;
    aInifile.Free;

    propw_title:='';
    fnd:=0;
    for i:=1 to length(props) do
    begin
      if (fnd=1)
        and (props[i]<>'"') then
        propw_title:=propw_title + props[i];
      if (props[i]='"')
        and (fnd<2) then
      begin
        inc(fnd);
      end;
      if fnd=1 then
      begin
        pos1:=i;
      end;
      if fnd=2 then
      begin
        pos2:=i;
        pos2:=i;
        break;
      end;
    end;

    mainw_title:='';
    fnd:=0;
    for i:=1 to length(main) do
    begin
      if (fnd=1)
        and (main[i]<>'"') then
        mainw_title:=mainw_title + main[i];
      if (main[i]='"')
        and (fnd<2) then
      begin
        inc(fnd);
      end;
      if fnd=1 then
      begin
        pos1:=i;
      end;
      if fnd=2 then
      begin
        pos2:=i;
        pos2:=i;
        break;
      end;
    end;

    propw_comment:='';
    fnd:=0;
    for i:=1 to length(props) do
    begin
      if props[i]=';' then
      begin
        pos1:=i+1;
        break;
      end;
    end;
    propw_comment:=copy(props,pos1,length(props)-pos1+1);

    mainw_comment:='';
    fnd:=0;
    for i:=1 to length(main) do
    begin
      if main[i]=';' then
      begin
        pos1:=i+1;
        break;
      end;
    end;
    mainw_comment:=copy(main,pos1,length(main)-pos1+1);

  end;
end;

procedure Tf_main.read_ini;
var
  aInifile: TIniFile;
begin

  aInifile := TIniFile.Create(extractfilepath(application.ExeName) + 'CompHelpGen.Ini');
  with aInifile do
  begin
    helpcompiler:=ReadString('HELP COMPILER', 'Microsoft HelpWorkshop', '');
    templ_prop:=ReadString('TEMPLATES', 'Properties', extractfilepath(application.ExeName) + 'property_template.txt');
    templ_method:=ReadString('TEMPLATES', 'Methods', extractfilepath(application.ExeName) + 'method_template.txt');
    templ_desc:=ReadString('TEMPLATES', 'Descriptions', extractfilepath(application.ExeName) + 'description_template.txt');

    prop_list:=ReadString('RTF TEMPLATES', 'Property List', extractfilepath(application.ExeName) + 'property_list.txt');
    prop_page:=ReadString('RTF TEMPLATES', 'Property Page', extractfilepath(application.ExeName) + 'property_page.txt');
    method_list:=ReadString('RTF TEMPLATES', 'Method List', extractfilepath(application.ExeName) + 'method_list.txt');
    method_page:=ReadString('RTF TEMPLATES', 'Method Page', extractfilepath(application.ExeName) + 'method_page.txt');
    event_list:=ReadString('RTF TEMPLATES', 'Event List', extractfilepath(application.ExeName) + 'event_list.txt');
    event_page:=ReadString('RTF TEMPLATES', 'Event Page', extractfilepath(application.ExeName) + 'event_page.txt');
    main_page:=ReadString('RTF TEMPLATES', 'Main Page', extractfilepath(application.ExeName) + 'main_page.txt');
  end;
  aInifile.Free;
end;

procedure Tf_main.write_ini;
var
  aInifile: TIniFile;
begin
  aInifile := TIniFile.Create(extractfilepath(application.ExeName) + 'CompHelpGen.Ini');
  with aInifile do
  begin
    WriteString('HELP COMPILER', 'Microsoft HelpWorkshop', helpcompiler);
    WriteString('TEMPLATES', 'Properties', templ_prop);
    WriteString('TEMPLATES', 'Methods', templ_method);
    WriteString('TEMPLATES', 'Descriptions', templ_desc);

    WriteString('RTF TEMPLATES', 'Property List', prop_list);
    WriteString('RTF TEMPLATES', 'Property Page', prop_page);
    WriteString('RTF TEMPLATES', 'Method List', method_list);
    WriteString('RTF TEMPLATES', 'Method Page', method_page);
    WriteString('RTF TEMPLATES', 'Event List', event_list);
    WriteString('RTF TEMPLATES', 'Event Page', event_page);
    WriteString('RTF TEMPLATES', 'Main Page', main_page);
  end;
  aInifile.Free;
end;

procedure Tf_main.FormActivate(Sender: TObject);
begin
  read_ini;
end;

procedure Tf_main.write_helpproject_file;
var afile  :textfile;
begin

  assignfile(afile,projectfile);
  rewrite(afile);

  writeln(afile,'; Do NOT modify this file manually');

  writeln(afile,'[OPTIONS]');
  writeln(afile,'COMPRESS=12 Hall Zeck');
  writeln(afile,'LCID=0x409 0x0 0x0 ; English (United States)');
  writeln(afile,'REPORT=Yes');
  writeln(afile,'TITLE=' + helptitle);
  writeln(afile,'COPYRIGHT=' + copyright_display);
  writeln(afile,'CITATION=' + copyright_print);
  writeln(afile,'HLP=' + helpfile);
  writeln(afile);
  writeln(afile,'[FILES]');
  writeln(afile,rtffile);
  writeln(afile);
  writeln(afile,'[WINDOWS]');
  writeln(afile,'Props="' + propw_title + '",(730,,300,),4,(r14876671),(r12632256),f2; ' + propw_comment);
  writeln(afile,'Main="' + mainw_title + '",,27904,,(r12632256),f2; ' + mainw_comment);

  closefile(afile);
end;

procedure Tf_main.NewHelpProjectfile1Click(Sender: TObject);
begin
  helptitle:='';
  copyright_display:='';
  copyright_print:='';
  helpfile:='';
  rtffile:='';
  propw_title:='';
  propw_comment:='';
  mainw_title:='';
  mainw_comment:='';
  projectfile:='Untitled.hpj';
end;

procedure Tf_main.tb_gen_projectClick(Sender: TObject);
var l     :string;
    save  :boolean;
begin

  l:='The following fields are blank:' + char(13) + char(10);
  if trim(helpfile)='' then
    l:=l + char(13) + char(10) + 'Help File';
  if trim(helptitle)='' then
    l:=l + char(13) + char(10) + 'Help Title';
  if trim(rtffile)='' then
    l:=l + char(13) + char(10) + 'RTF File';
  if trim(copyright_display)='' then
   l:=l + char(13) + char(10) + 'Display Copyright';
  if trim(copyright_print)='' then
   l:=l + char(13) + char(10) + 'Print/Paste Copyright';
  if trim(propw_title)='' then
   l:=l + char(13) + char(10) + 'Property Window Title bar text';
  if trim(propw_comment)='' then
   l:=l + char(13) + char(10) + 'Property Window comment';
  if trim(mainw_title)='' then
   l:=l + char(13) + char(10) + 'Main Window Title bar text';
  if trim(mainw_comment)='' then
   l:=l + char(13) + char(10) + 'Main Window comment';
  l:=l + char(13) + char(10) + 'Continue?';

  save:=false;
  if l <> 'The following fields are blank:' + char(13) + char(10)+ char(13) + char(10) + 'Continue?' then
  begin
    if MessageDlg(l, mtConfirmation, mbOkCancel, 0) = idok then
    begin
      save:=true;
    end;
  end
  else
    save:=true;

  if save then
  begin
    if trim(compnameexcl)='' then
      savedialog1.filename:=projectfile
    else
      savedialog1.filename:=lowercase(compnameexcl)+'.hpj';
      
    savedialog1.Title:='Generate Help Project file';
    savedialog1.FilterIndex:=3;
    if savedialog1.execute then
    begin
      projectfile:=savedialog1.FileName;

      write_helpproject_file;
    end;
  end;

end;

procedure Tf_main.About1Click(Sender: TObject);
var
  f_about: Tf_about;
begin
  f_about:=tf_about.create(self);
  f_about.showmodal;
  f_about.free;
end;

procedure Tf_main.Contents1Click(Sender: TObject);
begin
  application.HelpJump('hlp_contents')
end;

procedure Tf_main.HelpFile1Click(Sender: TObject);
var
  SI  :TStartupInfo;
  PI  :TProcessInformation;
  l   :string;
begin
  if trim(helpcompiler)='' then
  begin
    Application.MessageBox(pchar('Help Compiler name not valid !'),'Generate',MB_ICONHAND);
    exit;
  end;
  if CreateProcessAndWait(helpcompiler,' -x ' + projectfile,1) = 0 then
    Application.MessageBox(pchar('Helpfile created successfully !'),'Generate',MB_OK)
  else
    Application.MessageBox(pchar('Creation of Helpfile failed !'),'Generate',MB_ICONHAND);
end;

function CreateProcessAndWait(const AppPath, AppParams: String;
                              Visibility: word): DWord;
var
  SI: TStartupInfo;
  PI: TProcessInformation;
  Proc: THandle;
begin
  FillChar(SI, SizeOf(SI), 0);
  SI.cb := SizeOf(SI);
  SI.wShowWindow := Visibility;
  if not CreateProcess(PChar(AppPath), PChar(AppParams), Nil, Nil, False,
                   Normal_Priority_Class, Nil, Nil, SI, PI) then
  begin
//    showmessage('Failed to execute program');
    exit;
  end;
  Proc := PI.hProcess;
  CloseHandle(PI.hThread);
  if WaitForSingleObject(Proc, Infinite) <> Wait_Failed then
    GetExitCodeProcess(Proc, Result);
  CloseHandle(Proc);
end;


procedure Tf_main.fh_projectItemClick(Sender: TObject);
begin
  doload:=true;
  projectfile:=fh_project.Selected;

  OpenHelpProjectfile1Click(self);
end;

end.
